AppTitle "Grim Engine v0.2"

SetGfxDriver 1
Graphics 1024,768
SetBuffer BackBuffer()

Global gfx_width = 320 
Global gfx_height = 200 
Global pp_width# = gfx_width
Global pp_height = gfx_height
Global x_offset = (1024 - 320) / 2
Global y_offset = (768 - 200) / 2
Global center_width = pp_width / 2
Global center_height = gfx_height / 2
Global fov = 64
Global half_fov = fov / 2
Global distance_to_pp = center_width / Tan(half_fov)
Global angle_between_rays# = 0.2;(fov / pp_width#)
Global slice_size
Global half_slice
Global slice_pos
Global pov_angle = 180
Global pov_angle2 = 0
Global player_speed
Global player_start_x# 
Global player_start_y# 
Global ndistance
Global snapshot_num = 1
Global collision_distance
Global collision_distance2
Global jas_number
Global jas_angle 

Global line_inter_flag = 0

Global timer1
Global fps_counter = 0
Global current_fps

;Ray globals
Global ray_count = 0
Global rstart_x
Global rstart_y
Global ray_x#
Global ray_y#
Global ray_angle#
Global dx
Global dy
Global ds = 0
Global dist_count = 0


Global start_x#
Global start_y#
Global end_x#
Global end_y#
Global intersect_flag
Global mouse_flag = 0
Global num_linedefs = 0
Global mode_flag = 0
Global player_placed_flag = 0

Global Intersection_X#									; Values returned by the Lines_Intersect() function.
Global Intersection_Y#
Global Intersection_AB#
 
Global Intersection_CD#

Global vertex_image = LoadImage("vert.bmp")
Global mouse_image = LoadImage("pointer.bmp")
Global player_marker = LoadImage("p_dot.bmp")

MidHandle vertex_image
MidHandle mouse_image
MidHandle player_marker

Type Linedef
Field sx#
Field ex#
Field sy#
Field ey#
Field def_num
Field distance
Field intersected
End Type

timer1 = MilliSecs()

; Main loop
While Not state = 1
If MilliSecs() >= timer1 + 1000 Then
current_fps = fps_counter
fps_counter = 0
timer1 = MilliSecs()
EndIf
If KeyHit(1) Then End
If KeyHit(57) Then ; Space bar (Switches between render mode and map mode)
Select mode_flag
Case 0
If player_placed_flag = 1 Then
mode_flag = 1
EndIf
Case 1
mode_flag = 0
End Select
EndIf
Select mode_flag
Case 0
; ################################## Map Mode #######################################################
If MouseHit(2) Then
Select player_placed_flag
Case 0
player_placed_flag = 1
player_start_x = MouseX()
player_start_y = MouseY()
Case 1
player_placed_flag = 0
End Select
EndIf
Select player_placed_flag
Case 1
DrawImage player_marker,player_start_x,player_start_y ; Draw player dot
End Select
If MouseHit(1) Then
Select mouse_flag
Case 0
mouse_flag = 1
start_x# = MouseX()
start_y# = MouseY()
Case 1
mouse_flag = 0
create_linedef()
End Select
EndIf
end_x# = MouseX()
end_y# = MouseY()
Select mouse_flag
Case 1
Line start_x#,start_y#,MouseX(),MouseY()
DrawImage vertex_image,start_x#,start_y#
DrawImage vertex_image,MouseX(),MouseY()
End Select
If num_linedefs > 0 Then
For eln.Linedef = Each Linedef
If KeyDown(200) Then ; Up key (Move map up)
eln\sy# = eln\sy# - 1
eln\ey# = eln\ey# - 1
EndIf
If KeyDown(208) Then ; Down key (Move map down)
eln\sy# = eln\sy# + 1
eln\ey# = eln\ey# + 1
EndIf
If KeyDown(203) Then ; Left key (Move map left)
eln\sx# = eln\sx# - 1
eln\ex# = eln\ex# - 1
EndIf
If KeyDown(205) Then ; Right key (Move map right)
eln\sx# = eln\sx# + 1
eln\ex# = eln\ex# + 1
EndIf
Color 0,0,255
Line eln\sx#,eln\sy#,eln\ex#,eln\ey#
DrawImage vertex_image,eln\sx#,eln\sy#
DrawImage vertex_image,eln\ex#,eln\ey#
Next
EndIf
DrawImage mouse_image,MouseX(),MouseY()
; ################################## Map Mode #######################################################
Case 1
; ******************************** Render Mode ******************************************************
player_speed = 0
If KeyDown(200) Then ; Up key (Move map up)
player_speed = player_speed + 12
update_player_pos()
EndIf
If KeyDown(208) Then ; Down key (Move map down)
player_speed = player_speed + 12
update_player_pos2()
EndIf
If KeyDown(203) Then ; Left key (Move map left)
pov_angle = pov_angle - 3
pov_angle2 = pov_angle2 - 3
If pov_angle < 0 Then pov_angle = 359
If pov_angle2 < 0 Then pov_angle2 = 359
EndIf
If KeyDown(205) Then ; Right key (Move map right)
pov_angle = pov_angle + 3
pov_angle2 = pov_angle2 + 3
If pov_angle > 359 Then pov_angle = 0
If pov_angle2 > 359 Then pov_angle2 = 0
EndIf
dist_count = 0
ray_count = 0
cast_rays()
; ******************************** Render Mode ******************************************************
End Select
Color 255,0,0
Text 0,0, "Current FPS:" + current_fps
Flip
fps_counter = fps_counter + 1
Cls
Wend

Function create_linedef()
num_linedefs = num_linedefs + 1
n.Linedef = New Linedef
n\sx# = start_x#
n\sy# = start_y#
n\ex# = end_x#
n\ey# = end_y#
n\def_num = num_linedefs
n\intersected = 0
End Function

Function cast_rays()
ray_count = 0
jas_number = 0
jas_angle = 328
ray_angle = 328;(pov_angle - 32)
If ray_angle < 0 Then
jason# = Abs(ray_angle)
ray_angle = (360 - jason)
EndIf
Repeat
dist_count = 5000
line_inter_flag = 0
get_intersections() 
ray_angle = ray_angle + angle_between_rays
jas_angle = jas_angle + angle_between_rays
If ray_angle > 359 Then
ray_angle = 0
EndIf
ray_count = ray_count + 1
Until ray_count = pp_width
End Function

Function get_intersections() 
ray_x = player_start_x + dist_count*Cos(pov_angle + ray_angle)
ray_y = player_start_y + dist_count*Sin(pov_angle + ray_angle)
For b = 1 To num_linedefs
For el.Linedef = Each Linedef
If el\def_num = b Then
If Lines_Intersect(player_start_x#,player_start_y#,ray_x#,ray_y#,el\sx#,el\sy#,el\ex#,el\ey#) Then
dx = Abs (Intersection_X#-player_start_x)
dy = Abs (Intersection_Y#-player_start_y)
ds = Sqr((dx*dx) + (dy*dy))
ds = Cos(ray_angle)*ds
ndistance = ds
el\distance = ds
el\intersected = 1
EndIf
EndIf
Next
Next
z_order_slices()
update_plain_slice()
End Function

Function z_order_slices()
For c = 1 To num_linedefs
For eldef.Linedef = Each Linedef
If eldef\def_num = c Then
If eldef\intersected = 1 Then
If eldef\distance < ndistance Then
ndistance = eldef\distance
eldef\intersected = 0
EndIf
EndIf
EndIf
Next
Next
End Function

Function update_plain_slice()
slice_size = (64 * distance_to_pp) / ndistance
half_slice = slice_size / 2
slice_pos = center_height - half_slice
Color 0,255,0
If ray_count > 1 Then
Rect x_offset + ray_count,y_offset + slice_pos,1,slice_size,1
EndIf
End Function

Function update_player_pos()
player_start_x = player_start_x + Cos(pov_angle)*player_speed
player_start_y = player_start_y + Sin(pov_angle)*player_speed
End Function

Function update_player_pos2()
player_start_x = player_start_x + Cos(pov_angle2)*player_speed
player_start_y = player_start_y + Sin(pov_angle2)*player_speed
End Function

Function Lines_Intersect(Ax#, Ay#, Bx#, By#, Cx#, Cy#, Dx#, Dy#)
	Rn# = (Ay#-Cy#)*(Dx#-Cx#) - (Ax#-Cx#)*(Dy#-Cy#)
    Rd# = (Bx#-Ax#)*(Dy#-Cy#) - (By#-Ay#)*(Dx#-Cx#)
    If Rd# = 0 
		Return False
		Else
                Sn# = (Ay#-Cy#)*(Bx#-Ax#) - (Ax#-Cx#)*(By#-Ay#)
	Intersection_AB# = Rn# / Rd#
	Intersection_CD# = Sn# / Rd#
    Intersection_X# = Ax# + Intersection_AB#*(Bx#-Ax#)
    Intersection_Y# = Ay# + Intersection_AB#*(By#-Ay#)
If Intersection_AB# >= 0 And Intersection_AB# <= 1 And Intersection_CD# >= 0 And Intersection_CD# <= 1 Then
Return True
EndIf
	EndIf
End Function